# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator (autorest: 3.8.0, generator: @autorest/python@5.12.2)
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import functools
from typing import Any, Callable, Dict, Generic, Optional, TypeVar
import warnings

from azure.core.exceptions import ClientAuthenticationError, HttpResponseError, ResourceExistsError, ResourceNotFoundError, map_error
from azure.core.pipeline import PipelineResponse
from azure.core.pipeline.transport import AsyncHttpResponse
from azure.core.rest import HttpRequest
from azure.core.tracing.decorator_async import distributed_trace_async

from ... import models as _models
from ..._vendor import _convert_request
from ...operations._experiments_provider_operations import build_get_index_entity_by_id_request, build_get_updated_entity_ids_for_workspace_request
T = TypeVar('T')
ClsType = Optional[Callable[[PipelineResponse[HttpRequest, AsyncHttpResponse], T, Dict[str, Any]], Any]]

class ExperimentsProviderOperations:
    """ExperimentsProviderOperations async operations.

    You should not instantiate this class directly. Instead, you should create a Client instance that
    instantiates it for you and attaches it as an attribute.

    :ivar models: Alias to model classes used in this operation group.
    :type models: ~flow.models
    :param client: Client for service requests.
    :param config: Configuration of service client.
    :param serializer: An object model serializer.
    :param deserializer: An object model deserializer.
    """

    models = _models

    def __init__(self, client, config, serializer, deserializer) -> None:
        self._client = client
        self._serialize = serializer
        self._deserialize = deserializer
        self._config = config

    @distributed_trace_async
    async def get_index_entity_by_id(
        self,
        subscription_id: str,
        resource_group_name: str,
        workspace_name: str,
        body: Optional["_models.UnversionedEntityRequestDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject"] = None,
        **kwargs: Any
    ) -> "_models.UnversionedEntityResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject":
        """get_index_entity_by_id.

        :param subscription_id: The Azure Subscription ID.
        :type subscription_id: str
        :param resource_group_name: The Name of the resource group in which the workspace is located.
        :type resource_group_name: str
        :param workspace_name: The name of the workspace.
        :type workspace_name: str
        :param body:
        :type body:
         ~flow.models.UnversionedEntityRequestDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject
        :keyword callable cls: A custom type or function that will be passed the direct response
        :return:
         UnversionedEntityResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject,
         or the result of cls(response)
        :rtype:
         ~flow.models.UnversionedEntityResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject
        :raises: ~azure.core.exceptions.HttpResponseError
        """
        cls = kwargs.pop('cls', None)  # type: ClsType["_models.UnversionedEntityResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject"]
        error_map = {
            401: ClientAuthenticationError, 404: ResourceNotFoundError, 409: ResourceExistsError
        }
        error_map.update(kwargs.pop('error_map', {}))

        content_type = kwargs.pop('content_type', "application/json")  # type: Optional[str]

        if body is not None:
            _json = self._serialize.body(body, 'UnversionedEntityRequestDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject')
        else:
            _json = None

        request = build_get_index_entity_by_id_request(
            subscription_id=subscription_id,
            resource_group_name=resource_group_name,
            workspace_name=workspace_name,
            content_type=content_type,
            json=_json,
            template_url=self.get_index_entity_by_id.metadata['url'],
        )
        request = _convert_request(request)
        request.url = self._client.format_url(request.url)

        pipeline_response = await self._client._pipeline.run(request, stream=False, **kwargs)
        response = pipeline_response.http_response

        if response.status_code not in [200]:
            map_error(status_code=response.status_code, response=response, error_map=error_map)
            error = self._deserialize.failsafe_deserialize(_models.ErrorResponse, pipeline_response)
            raise HttpResponseError(response=response, model=error)

        deserialized = self._deserialize('UnversionedEntityResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject', pipeline_response)

        if cls:
            return cls(pipeline_response, deserialized, {})

        return deserialized

    get_index_entity_by_id.metadata = {'url': '/flow/v1.0/flowexperiments/getIndexEntities'}  # type: ignore


    @distributed_trace_async
    async def get_updated_entity_ids_for_workspace(
        self,
        subscription_id: str,
        resource_group_name: str,
        workspace_name: str,
        body: Optional["_models.UnversionedRebuildIndexDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject"] = None,
        **kwargs: Any
    ) -> "_models.UnversionedRebuildResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject":
        """get_updated_entity_ids_for_workspace.

        :param subscription_id: The Azure Subscription ID.
        :type subscription_id: str
        :param resource_group_name: The Name of the resource group in which the workspace is located.
        :type resource_group_name: str
        :param workspace_name: The name of the workspace.
        :type workspace_name: str
        :param body:
        :type body:
         ~flow.models.UnversionedRebuildIndexDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject
        :keyword callable cls: A custom type or function that will be passed the direct response
        :return:
         UnversionedRebuildResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject,
         or the result of cls(response)
        :rtype:
         ~flow.models.UnversionedRebuildResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject
        :raises: ~azure.core.exceptions.HttpResponseError
        """
        cls = kwargs.pop('cls', None)  # type: ClsType["_models.UnversionedRebuildResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject"]
        error_map = {
            401: ClientAuthenticationError, 404: ResourceNotFoundError, 409: ResourceExistsError
        }
        error_map.update(kwargs.pop('error_map', {}))

        content_type = kwargs.pop('content_type', "application/json")  # type: Optional[str]

        if body is not None:
            _json = self._serialize.body(body, 'UnversionedRebuildIndexDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject')
        else:
            _json = None

        request = build_get_updated_entity_ids_for_workspace_request(
            subscription_id=subscription_id,
            resource_group_name=resource_group_name,
            workspace_name=workspace_name,
            content_type=content_type,
            json=_json,
            template_url=self.get_updated_entity_ids_for_workspace.metadata['url'],
        )
        request = _convert_request(request)
        request.url = self._client.format_url(request.url)

        pipeline_response = await self._client._pipeline.run(request, stream=False, **kwargs)
        response = pipeline_response.http_response

        if response.status_code not in [200]:
            map_error(status_code=response.status_code, response=response, error_map=error_map)
            error = self._deserialize.failsafe_deserialize(_models.ErrorResponse, pipeline_response)
            raise HttpResponseError(response=response, model=error)

        deserialized = self._deserialize('UnversionedRebuildResponseDtoExperimentIndexEntityExperimentAnnotationsExperimentPropertiesExtensibleObject', pipeline_response)

        if cls:
            return cls(pipeline_response, deserialized, {})

        return deserialized

    get_updated_entity_ids_for_workspace.metadata = {'url': '/flow/v1.0/flowexperiments/rebuildIndex'}  # type: ignore

